(function (window) {

if (!!window.JCContactMap) {
    return;
}

window.JCContactMap = function (arParams) {
    this.params = [];
    this.map = null;
    this.collection = null;

    if (typeof arParams === 'object') {
        this.params = arParams;
    }

    this.initConfig();
};

window.JCContactMap.prototype.initMap = function() {
    if (!window.ymaps)
        return;

    this.map = new window.ymaps.Map(this.params.MAP_CONTAINER_ID, {
        center: this.params.CENTER_POINT,
        zoom: this.params.ZOOM
    });

    var collection = new ymaps.GeoObjectCollection(null, {});
    for (var i = 0, cnt = this.params.SHOPS.length; i<cnt; i++) {
        var shop = this.params.SHOPS[i];
        var placemark =
            new ymaps.Placemark(shop.POINT,
            {
                hintContent: shop.NAME
            },
            {
                // Необходимо указать данный тип макета.
                iconLayout: 'default#image',
                // Своё изображение иконки метки.
                iconImageHref: this.params.POINT_PICTURE_HREF,
                // Размеры метки.
                iconImageSize: [63, 63] ,
                // Смещение левого верхнего угла иконки относительно
                // её "ножки" (точки привязки).
                iconImageOffset: [-31, -31]
            }
        );

        collection.add(placemark);

        this.map.geoObjects.add(placemark);
        $("#"+shop.ELEMENT_ID+">a").bind("click",
            {
                placemarkIndex: i,
                contactObjectMap: this
            },
            this.selectPlacemark
        );
    }
};

window.JCContactMap.prototype.selectPlacemark = function(event) {
    var placemarkIndex = event.data.placemarkIndex,
        map = event.data.contactObjectMap.map,
        shops = event.data.contactObjectMap.params.SHOPS,
        shopsCount = event.data.contactObjectMap.params.SHOPS.length;

    for (var i = 0; i<shopsCount; i++) {
        var geoObject = map.geoObjects.get(i);
        geoObject.options.set('visible', i == placemarkIndex);

        if (i == placemarkIndex) {
            $("#"+shops[i].ELEMENT_ID+">a").parent().addClass("active");
            map.setCenter(geoObject.geometry.getCoordinates(), 16);
        } else {
            $("#"+shops[i].ELEMENT_ID+">a").parent().removeClass("active");
        }
    }
};

window.JCContactMap.prototype.initConfig = function() {

};

})(window);
